;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: debugging -*-
#|
-----------------------------------------------------------------------------------
TITLE: Tools for Compiler Debugging
-----------------------------------------------------------------------------------
File:    debugging.em
Version: 1.7 (last modification on Mon Jul  5 10:43:04 1993)
State:   published

DESCRIPTION:

DOCUMENTATION:

NOTES:

REQUIRES:

PROBLEMS:

AUTHOR:
Ingo Mohr

CONTACT: 
Ingo Mohr

HISTORY: 
Log for /export/home/saturn/imohr/Lisp/Apply/debugging.em[1.0]
	Thu Apr  1 09:07:30 1993 imohr@isst save $
 Some debugging tools for compiler debugging.
 
debugging.em[1.1] Thu Apr  1 13:04:52 1993 akind@isst proposed $
 [Thu Apr  1 13:01:39 1993] Intention for change:
 Toggle verbose for type inference.
 Toggle verbose for type inference.
 
debugging.em[1.2] Fri May  7 15:19:53 1993 akind@isst proposed $
 New flag for ti.
 
debugging.em[1.3] Fri May  7 15:37:33 1993 akind@isst proposed $
 
debugging.em[1.4] Fri May  7 16:11:07 1993 akind@isst proposed $
 
debugging.em[1.5] Thu May 27 14:34:43 1993 hfried@isst proposed $
 
 
debugging.em[1.6] Thu Jun  3 08:30:36 1993 imohr@isst proposed $
 [Thu Jun  3 08:28:13 1993] Intention for change:
 import interaction functions into package USER
 ok
 
debugging.em[1.7] Tue Jul  6 16:09:32 1993 akind@isst published $
 [Mon Jul  5 09:59:26 1993] Intention for change:
 Start/end analying a fun.
 

-----------------------------------------------------------------------------------
|#

#module-name debugging
#module-import
(level-0-eulisp)
#module-syntax-import 
(level-0-eulisp)
#module-syntax-definitions

#module-header-end

(export-syntax development-mode
	       ti-verbose
	       ti-break)
(export *development-mode*		; until macro exp. is hygienic in EL
	*ti-verbose*			; printing on/off during ti
	toggle-ti-verbose
	*ti-break*			; stop/go ahead at type clash
	toggle-ti-break
        toggle-code-debug
        code-debug
	analysed-fun                    ; answer which function is analysed now
	start-analyse-fun
	end-analyse-fun)

(cl:import '(toggle-ti-verbose toggle-ti-break toggle-code-debug analysed-fun) 
           (cl:find-package "USER"))

(deflocal *development-mode* t)

(defmacro development-mode ()
  '*development-mode*)

(deflocal *code-debug* nil)

(defun toggle-code-debug ()
  (if *code-debug*
    (setq *code-debug* ())
    (setq *code-debug* t)))

(defun code-debug () *code-debug*)

;;; ---------------------------------------------------------------------------
;;; Protocol and break flag for type inference
;;; ---------------------------------------------------------------------------

(deflocal *ti-verbose* nil)
(deflocal *ti-break* nil)

(defmacro ti-verbose ()
  '*ti-verbose*)

(defun toggle-ti-verbose ()
  (if *ti-verbose*
      (setq *ti-verbose* nil)
    (setq *ti-verbose* t)))   

(defmacro ti-break ()
  '*ti-break*)

(defun toggle-ti-break ()
  (if *ti-break*
      (setq *ti-break* nil)
    (setq *ti-break* t)))

;;; ---------------------------------------------------------------------------
;;; What function is being analysed?
;;; ---------------------------------------------------------------------------

(deflocal *analysed-fun* '())

(defun start-analyse-fun (fun)
  (setq *analysed-fun* (cons fun *analysed-fun*)))

(defun end-analyse-fun (fun)
  (setq *analysed-fun* (cdr *analysed-fun*)))

(defun analysed-fun ()
  (if *analysed-fun*
      (car *analysed-fun*)
    nil))

#module-end
