;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: side-effects-h -*-
#|
-----------------------------------------------------------------------------------
TITLE: 
-----------------------------------------------------------------------------------
File:    side-effects-h.em
Version: 1.3 (last modification on Thu Mar 25 11:05:09 1993)
State:   published

DESCRIPTION:
definition of the structures for side-effect analyse and teh function
 set-side-effect

DOCUMENTATION:
NOTES:
REQUIRES:
PROBLEMS:
AUTHOR: Dr. Horst Friedrich
CONTACT: horst.friedrich@isst.fhg.de 

HISTORY: 
Log for /export/home/saturn/imohr/Lisp/Apply/side-effects-h.em[1.0]
	Thu Mar 25 08:54:28 1993 hfried@isst proposed $
 Zur Seiteneffektanalyse
 
side-effects-h.em[1.1] Thu Mar 25 11:22:09 1993 hfried@isst proposed $
 [Thu Mar 25 08:56:26 1993] Intention for change:
 new head
 
side-effects-h.em[1.2] Tue Apr 13 14:11:27 1993 hfried@isst proposed $
 [Thu Mar 25 11:55:21 1993] Intention for change:
 
side-effects-h.em[1.3] Mon Jun 21 11:49:36 1993 hfried@isst published $
 [Tue Apr 13 14:17:15 1993] Intention for change:
 

-----------------------------------------------------------------------------------
|#

#module-name side-effects-h
#module-import
(level-1-eulisp
 simple-programming
 accessors
)
#module-syntax-import 
(level-1-eulisp)
#module-syntax-definitions

;; local macro definitions

(defmacro defclass (name supers . slots)
  (make-class-definition name
                         supers 
                         slots))


#module-header-end

;;exports
(export 
  gloc
  gloc-p
  fgloc
  set-read-side-effect
  set-write-side-effect
  <gloc>
  <fgloc>
)

; class-definitions
; ------------------

(defclass gloc () 
;         ----
  (gplace :initform ())
  (type   :initform ())
)

(defclass fgloc ()
;         -----
  fun ; fgloc belongs to this function
  (glocs :initform ())
)

;;definitions and init-forms

(defun set-read-side-effect (fun key value)
  (let ((gloc (make <gloc> :gplace value))
        (fread-gloc (?fread-gloc fun)))
  (if fread-gloc
    (setf (?glocs fread-gloc)
          (cons gloc (?glocs fread-gloc)))
    (setf (?fread-gloc fun)
          (make <fgloc> :fun fun
                :glocs (list gloc))))
  (setf (?sys-glocs fun) ^t))
)

(defun set-write-side-effect (fun key value)
  (let ((gloc (make <gloc> :gplace value))
        (fwrite-gloc (?fwrite-gloc fun)))
  (if fwrite-gloc
    (setf (?glocs fwrite-gloc)
          (cons gloc (?glocs fwrite-gloc)))
    (setf (?fwrite-gloc fun)
          (make <fgloc> :fun fun
                :glocs (list gloc))))
  (setf (?sys-glocs fun) ^t))
)

#module-end
