;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: standard-mop -*-
#|
-----------------------------------------------------------------------------------
TITLE: a very short characterisation of the content
-----------------------------------------------------------------------------------
File:    standard-mop.em
Version: 1.12 (last modification on Tue Oct 19 09:15:51 1993)
State:   proposed

DESCRIPTION:
the description of the content

DOCUMENTATION:
where an external documentation can be found (filename and format, title of a
paper ...)

NOTES:
remarks about future extensions ...

REQUIRES:
ressources which are used but can't be declared in the import section

PROBLEMS:
known problems or errors that are not yet eliminated

AUTHOR:
the original author

CONTACT: 
the person which is currently responsible for this file

HISTORY: 
Log for /export/home/saturn/hfried/Lisp/Apply/standard-mop.em[1.0]
	Mon Mar 22 16:37:54 1993 imohr@isst save $
 compile time MOP for standard classes 
 (only method definitions)
 
standard-mop.em[1.1] Tue Mar 23 09:47:41 1993 wheick@isst proposed $
 [Mon Mar 22 17:28:44 1993] Intention for change:
 class-representation inserted
 
standard-mop.em[1.2] Thu Apr  8 15:21:02 1993 imohr@isst proposed $
 code generation for classes ok
 
standard-mop.em[1.3] Tue Apr 20 16:10:08 1993 imohr@isst proposed $
 [Thu Apr  8 15:21:58 1993] Intention for change:
 --- no intent expressed ---
standard-mop.em[1.4] Mon May  3 13:32:59 1993 imohr@isst proposed $
 vector classes    
 
standard-mop.em[1.5] Tue May  4 08:53:39 1993 imohr@isst proposed $
 ~vector-class-element-initfunction
 
standard-mop.em[1.6] Mon Aug 30 15:25:21 1993 imohr@isst proposed $
 [Mon Aug 30 14:14:20 1993] Intention for change:
 collecting subclasses in a class
 
standard-mop.em[1.7] Wed Sep 15 11:57:23 1993 imohr@isst save $
 [Mon Sep 13 08:29:08 1993] Intention for change:
 complete generic functions
 
standard-mop.em[1.8] Wed Sep 15 13:17:08 1993 imohr@isst save $
 [Wed Sep 15 13:10:20 1993] Intention for change:
 removing some simple bugs
 
standard-mop.em[1.9] Wed Sep 15 16:58:41 1993 imohr@isst save $
 [Wed Sep 15 14:43:04 1993] Intention for change:
 #+ discrimination-depth
 
standard-mop.em[1.10] Thu Sep 16 11:41:52 1993 imohr@isst proposed $
 [Thu Sep 16 11:28:58 1993] Intention for change:
 the representation of vector classes can't be checked because 
 accessor functions for vector classes are needed during computatntations
 
standard-mop.em[1.11] Thu Sep 30 16:16:43 1993 imohr@isst proposed $
 [Wed Sep 29 13:45:28 1993] Intention for change:
 extending slot-description-protocol
 
standard-mop.em[1.12] Tue Oct 19 09:16:10 1993 hfried@isst proposed $
 [Tue Oct 19 09:14:28 1993] Intention for change:
 ausschriften
 

-----------------------------------------------------------------------------------
|#

#module-name standard-mop
#module-import
(level-0-eulisp 
 lzs-mop 
 lzs
 el2lzs-literals
 (only (<%pointer-to-vector>) whc-classes)
 (only (<%string>) tail-module)
 (only (find format) common-lisp))
#module-syntax-import 
(level-0-eulisp)
#module-syntax-definitions

#module-header-end

;;; -----------------------------------------------------------------------------------
;;; ~class-of
;;; -----------------------------------------------------------------------------------

(defmethod ~class-of (object)
  (literal-type object))

(defmethod ~class-of ((object <defined-class>))
  (?class object))

;;; -----------------------------------------------------------------------------------
;;; Class Introspection
;;; -----------------------------------------------------------------------------------

(defmethod ~class-name ((class <class-def>))
  (?identifier class))

(defmethod ~class-precedence-list ((class <class-def>))
  (?class-precedence-list class))

(defmethod ~class-slot-descriptions ((class <class-def>))
  (?effective-slots class))

(defmethod ~class-initargs ((class <class-def>))
  (?initargs class))

(defmethod ~class-representation ((class <class-def>))
  (?representation class))

(defmethod ~find-slot-description ((class <class-def>) slot-name)
  (find slot-name (~class-slot-descriptions class)
        :key #'~slot-description-name))

(defmethod ~class-subclasses ((class <class-def>))
  (?subclasses class))

;;; -----------------------------------------------------------------------------------
;;; Slot Introspection
;;; -----------------------------------------------------------------------------------

(defmethod ~slot-description-name ((slot <slot-desc>))
  (?identifier slot))

(defmethod ~slot-description-initfunction ((slot <slot-desc>))
  (?initfunction slot))

(defmethod ~slot-description-slot-reader ((slot <slot-desc>))
  (?reader slot))

(defmethod ~slot-description-slot-writer ((slot <slot-desc>))
  (?writer slot))

(defmethod ~slot-description-type ((slot <slot-desc>))
  (?type slot))

(defmethod ~slot-description-initarg ((slot <slot-desc>))
  (?initarg slot))

(defmethod ~slot-description-initvalue ((slot <slot-desc>))
  (?initvalue slot))

;;; -----------------------------------------------------------------------------------
;;; Generic Function Introspection
;;; -----------------------------------------------------------------------------------

(defmethod ~generic-function-domain ((gf <generic-fun>))
  (?domain gf))

(defmethod ~generic-function-method-class ((gf <generic-fun>))
  (?method-class gf))

(defmethod ~generic-function-methods ((gf <generic-fun>))
  (?method-list gf))

(defmethod ~generic-function-method-lookup-function ((gf <generic-fun>))
  (?method-lookup-fun gf))

(defmethod ~generic-function-discriminating-function ((gf <generic-fun>))
  (?discriminating-fun gf))

(defmethod ~generic-function-discrimination-depth ((gf <generic-fun>))
  (?discrimination-depth gf))

;;; -----------------------------------------------------------------------------------
;;; Method Introspection
;;; -----------------------------------------------------------------------------------

(defmethod ~method-domain ((method <method-def>))
  (?domain method))

(defmethod ~method-function ((method <method-def>))
  (?fun method))

(defmethod ~method-generic-function ((method <method-def>))
  (?generic-fun method))

;;; -----------------------------------------------------------------------------------
;;; Introspection of Vector Classes
;;; -----------------------------------------------------------------------------------

(defmethod ~vector-class-instance-length (vector-class)
  (let ((initfun (~slot-description-initfunction 
                  (~find-slot-description vector-class ^length))))
    (if (null initfun)
      nil
      (init-fun-value (?body initfun) vector-class))))

(defgeneric init-fun-value (initform class))
(defmethod init-fun-value ((initform <named-const>) class)
  (if (eq (?value initform) ^unknown)
    (error-bad-init-form class initform)
    (init-fun-value (?value initform))))
(defmethod init-fun-value ((initform <literal-instance>) class)
  initform)
(defmethod init-fun-value ((initform <integer>) class)
  initform)
(defmethod init-fun-value (initform class)
  (error-bad-init-form class initform))

(defun error-bad-init-form (class initform)
  (format t "~% -------------------- error ------------------------")
  (format t "~% invalid initialization form ~A for the vector class ~A"
          initform class)
  (format t "~% ---------------------------------------------------~%")
  nil)

(defmethod ~vector-class-element-type (vector-class)
  (and 
   #|(check-for-vetcor-class vector-class (?representation vector-class))|#
   (~slot-description-type 
    (~find-slot-description vector-class ^element))))

(defmethod ~vector-class-element-initfunction (vector-class)
  (and
   #|(check-for-vetcor-class vector-class (?representation vector-class))|#
   (~slot-description-initfunction 
    (~find-slot-description vector-class ^element))))

; check-for-vector-class cannot use the representation for its test because the
; vector class accessors are already needed during computation of representations
;
;(defgeneric check-for-vetcor-class (class representation))
;(defmethod check-for-vetcor-class 
;           (class (representation <%pointer-to-vector>))
;  t)
;(defmethod check-for-vetcor-class 
;           ((class <%string>) representation)
;  ;??? why this is necessary ???
;  t)
;(defmethod check-for-vetcor-class (class representation)
;  (format t "~%Error: ~A (module ~A) is no vector class"
;          (?identifier class)
;          (?module-id class))
;  nil)

#module-end
