;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: spint -*-
#|
-----------------------------------------------------------------------------------
TITLE: EL-in-CL: module spint
-----------------------------------------------------------------------------------
File:    spint.em
Version: 1.2 (last modification on Wed Sep  1 07:31:13 1993)
State:   published

DESCRIPTION:

DOCUMENTATION:

NOTES:

REQUIRES:

PROBLEMS:
In Franz Allegro (Unix) the class <spint> must be mapped to the CL-class
INTEGER, because a class FIXNUM doesn't exists

AUTHOR:
Ingo Mohr

CONTACT: 

HISTORY: 
Log for /export/home/saturn/imohr/Lisp/EulispModules/spint.em[1.0]
	Fri Mar  5 15:40:29 1993 imohr@isst proposed $
 
spint.em[1.1] Wed Mar 10 13:13:00 1993 imohr@isst proposed $
 [Mon Mar  8 14:36:16 1993] Intention for change:
 Log not inside comments
 - with new file header
 - Log-message inside balanced comment
 
spint.em[1.2] Wed Sep  1 07:31:44 1993 ukriegel@isst published $
 [Tue Aug 31 14:01:25 1993] Intention for change:
 :cmu
 done
 

-----------------------------------------------------------------------------------
|#

#module-name spint
#module-import
(eulisp-kernel
 (only (fixnump) ccl)
 #+(and :ALLEGRO :FRANZ-INC)
 (only (find-class class-name) common-lisp)
 #+:cmu
 (only (find-class class-name) pcl)
 number)
#module-syntax-import 
(eulisp-kernel)
#module-syntax-definitions

#module-header-end

(export single-precision-integer-p)
(expose (only (evenp oddp)
          common-lisp))


#-(or :cmu (and :ALLEGRO :FRANZ-INC))
(progn
  (make-eulisp-class spint fixnum) 
; the alias with a short namemust appear before the following assignment, to
; rename the CL-class to single-precision-integer and not to spint
  (make-eulisp-class single-precision-integer fixnum)
)

#+(or :cmu (and :ALLEGRO :FRANZ-INC))
(progn 
  (export <single-precision-integer>) 
  (export <spint>)
  (defconstant <single-precision-integer> (find-class 'cl:integer))
  (defconstant <spint> (find-class 'cl:integer))
  (setf (find-class '<single-precision-integer>) <single-precision-integer>)
  (setf (find-class '<spint>) <spint>)
)


(defun single-precision-integer-p (x) 
  (fixnump x))

#module-end


