;;;-*- Mode: Lisp; Syntax: Common-Lisp; Base: 10; Package: vector -*-
#|
-----------------------------------------------------------------------------------
TITLE: create and ref to vectors
-----------------------------------------------------------------------------------
File:    vector.em
Version: 1.2 (last modification on Thu Jun 17 15:28:08 1993)
State:   published

DESCRIPTION:
make-vector, vector-ref and (setf (vector-ref ..) ..)

DOCUMENTATION:
where an external documentation can be found (filename and format, title of a
paper ...)

NOTES:
remarks about future extensions ...

REQUIRES:
ressources which are used but can't be declared in the import section

PROBLEMS:
known problems or errors that are not yet eliminated

AUTHOR:
Dr. Horst Friedrich

CONTACT: 
Dr. Horst Friedrich

HISTORY: 

31.11.92 creation of this file

Log for /export/home/saturn/imohr/Lisp/EulispModules/vector.em[1.0]
	Fri Mar  5 15:40:39 1993 imohr@isst proposed $
 
vector.em[1.1] Wed Mar 10 13:13:34 1993 imohr@isst proposed $
 [Mon Mar  8 14:36:57 1993] Intention for change:
 Log not inside comments
 - with new file header
 - Log-message inside balanced comment
 
vector.em[1.2] Thu Jun 17 15:22:15 1993 imohr@isst published $
 [Thu Jun 17 15:18:36 1993] Intention for change:
 + #module-end
 

-----------------------------------------------------------------------------------
|#

#module-name vector
#module-import 
( level-0-eulisp
  (only (make-array svref svset vector) common-lisp)
) 

#module-syntax-import (eulisp-kernel 
                       (only (defsetf) common-lisp))
#module-syntax-definitions

;--- defmacro forms

#module-header-end

;  #######
;  exports
;  #######

;        ########################
(export make-vector make-initialized-vector vector-ref);  (setf vector-ref) 
;        ########################

(defun make-vector (size)
  (make-array size))

(defmacro make-initialized-vector objs ; *ak*
  `(vector ,@objs))

(defun vector-ref (vec idx)
  (svref vec idx))

(defsetf vector-ref (vec idx) (new-value)
  `(setf (svref ,vec ,idx) ,new-value))

(make-eulisp-class vector array)

#module-end
